<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Source: session.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: session.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* based on the specifications and cuelist of a level  
* forwards cue actions to plugins that are addressed in a cue.  
* stores, recalls and cancels plugin listeners  
* start a session with the plaitools app
*
* each session creats a webview that allows cueing and monitoring
*
* @requires json5
* @requires events
*
* @requires time
* @requires medley
* @requires variables
* @requires errors
*
* @module session
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const events = require('events')
const JSON5 = require('json5')

const medley = require('./medley.js')
const var_module = require('./variables.js')

const { DesignError } = require('./errors')

/**
* Create or resume session based on level
* for resumed sessions restore listeners
* for new sessions dispatch START cue
*
* @param {Object} data - database content of stored sessions in moment of game resume or build
* @param {Object} db - Mongo Databse connection object
* @param {Object} plugins - List of plugins that are activated for the game
* @param {Object} client - socket io namespace
*/
class Session {
  constructor(data, db, client, plugins) {
    this.doc = db.sessions.document({"_id":data._id})
    this.leveldoc = db.level.document({"name":data.level})
    this.plugins = plugins
    this.db = db

    Object.assign(this, data)

    /** local store of reference names to make finding references easier */
    this.references = []

    /** collections whose documents can be referenced */
    this.reference_collections = this.custom_collections.slice()
    this.reference_collections.push("sessions")
    
    if(!data.name) {
      this.name = this._id.toString()
    }
    
    /**
    * holds cues while they dispatched and installing their listener
    * only first item is being dispatched and then removes iteself
    *
    * items can be string or query addressing one cue
    */
    this.cue_stack = []
    
    /** list of listener objects that are pending. 
    * Corelates with listener DB Collection but also contains plugin specific js objects
    */ 
    this.queue = []
    
    /** eventemitter instance is forwarded to plugins on cue to interact with this session */
    this.event = new events.EventEmitter()
    
    this.client = client
    this.client.on('connection', this.clientConnection.bind(this))
  }

  setup(args) {
    return new Promise((resolve, reject) => {
      let reference_promises = []
      let references = {}

      if(!this["config"]) {
        this["config"] = {"arguments":{}}
        log.warn(this.name, "no config defined for " + data.level)
      } else if(!this.config.hasOwnProperty("arguments")) {
        this.config["arguments"] = {}
      }

      if(Array.isArray(args)) {
        let i = 0
        for(let config_arg in this.config["arguments"]) {
          if(i &lt; args.length) {
            references[config_arg] = args[i]
            i++
          } else {
            references[config_arg] = this.config["arguments"][config_arg]
          }
        }
      } else {
        references = Object.assign(this.config["arguments"], args)
      }

      for(let ref in references) {
        if(references[ref].query &amp;&amp; references[ref].collection) {
          reference_promises.push(this.createReference(references[ref].collection, references[ref].query, ref))
        } else {
          log.warn(this.name, "argument " + ref + " was not assigned and has no default document")
        }
      }

      Promise.all(reference_promises)
      .then(result => {
        log.info(this.name, "Created Session based on '" + this.level + "' " + this._id)
        return resolve()
      })
      .catch(error => {
        return reject(error)
      })
    })
  }

  reload() {
    return new Promise((resolve, reject) => {
      let restored_listener = []

      let load_references_promises = this.reference_collections.map(coll => {
        return this.loadReferences(coll)
      })

      Promise.all(load_references_promises)
      .then(result => {
        return this.db.listener.find({_session:this._id})
      })
      .then(result => {
        if(result.length) {
          let cue_promises = []
          for(let l of result) {
            let cue_forwarding = {}
            cue_forwarding[l._type] = l[l._type]
            cue_promises.push(Promise.resolve(this.forwardCue(cue_forwarding, l._plugin, l._origin, l._path, l.chapter, new Date(l._date))))
            restored_listener.push(l)
          }
          log.info(this.name, "Restore " + result.length + " listener")
          
          return Promise.all(cue_promises)
        } else {
          return
        }
      })
      .then(result => {
        if(result) {
          for(let i = 0; i &lt; result.length; i++) {
            this.enqueue(restored_listener[i], result[i])
          }
        }
        log.info(this.name, "Resume Session based on '" + this.level + "' " + this._id)
        return resolve()
      })
      .catch(err => {
        return reject(err)
      })
    })
  }
  
  
  createReference(collection, query, reference) {
    return new Promise((resolve, reject) => {
      if(!this.db.hasOwnProperty(collection)) {
        return reject("can not create reference. Collection " + collection + " doesn't exist.")
      }
      
      if(Array.isArray(query)) {
        query = query[0]// {name:{$in:query}}
      }
      if(typeof query === 'string') {
        try {
          query = JSON5.parse(query)
        } catch(err) {
          if(err instanceof SyntaxError) {
            query = {"name":query}
          } else {
            log.warn(this.name, 'Error when parsing to json:')
            log.warn(this.name, err)
          }
        }
      }
      
      log.debug(this.name, "creating reference " + reference + " in " + collection + ":")
      log.debug(this.name, query)

      this.removeReference(reference, collection)
      .then(result => {
        if(result) {
          log.debug(this.name, "replace " + result + " references to " + reference)
        }
        return this.db[collection].push(query, {sessions:{_id:this._id, reference:reference}})
      })
      .then(result => {
        if(result.matchedCount > 0) {
          // this.extra_references.push({collection:collection, query:query, name:reference})
          let duplicate = false
          for(let r of this.references) {
            if(r.name == reference) {
              duplicate = true
            }
          }
          if(!duplicate) {
            this.references.push({collection:collection, query:query, name:reference})
          }
          log.info(this.name, result.matchedCount + " referenced as " + reference + " in " + collection)
        } else {
          log.warn(this.name, collection + "." + reference + " is currently not referencing any document")
        }
        
        resolve(result)
      })
      .catch(error => {
        // log.error(this.name, error)
        return reject(error)
      })
    })
  }

  /**
   * search for all references in all custom collections and arrange them in one object.
   * 
   * references are arranged like this:
   * 
   * {&lt;reference1_name>:[&lt;document1>,&lt;document2>,...], &lt;reference2_name>:[&lt;document1>,...]}
   *
   * @return {Promise} - resolves with document containing all referenced documents
   */
  getAllReferences() {
    return new Promise((resolve, reject) => {
      let get_references_promises = this.reference_collections.map(coll => {
        return this.db[coll].find({'sessions._id':this._id})
      })
  
      let references = {}
  
      Promise.all(get_references_promises)
      .then(result => {
        for(let documents of result) {
          for(let doc of documents) {
            for(let session of doc.sessions) {
              if(this.db.sessions.compareIDs(session._id, this._id)) {
                if(!references.hasOwnProperty(session.reference)) {
                  references[session.reference] = []
                }
                references[session.reference].push(doc)
              }
            }
          }
        }
        return resolve(references)
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  /**
   * find referenced documents in colleciton and collect reference names.
   * 
   * append found references to list of reference names/collections `this.references`
   *
   * @param {string} collection name of existing data collection
   * @returns {Promise} resolves once all references are collected
   */
  loadReferences(collection) {
    return new Promise((resolve, reject) => {
      this.db[collection].find({"sessions._id":this._id})
      .then(result => {
        if(result.length) {
          for(let ref of result) {
            for(let session_ref of ref.sessions) {
              if(this.db[collection].compareIDs(session_ref._id, this._id)) {
                let duplicate = false
                for(let r of this.references) {
                  if(r.name == session_ref.reference) {
                    duplicate = true
                  }
                }
                if(!duplicate) {
                  this.references.push({collection:collection, name:session_ref.reference})
                  log.debug(this.name, "load reference " + session_ref.reference + " from " + collection)
                }
              }
            }
          }
        }
        return resolve()
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  /**
   * Remove reference to document(s)
   *
   * @param {string} reference - name of reference (E.g. PlayerA)
   * @param {string} [collection] - name of collection the reference is in. Remove in all collections if none
   * 
   * @returns {Promise} - resolves with count of documents where the reference was removed
   */
  removeReference(reference, collection) {
    return new Promise((resolve, reject) => {
      if(collection) {
        this.removeReferenceByQuery(collection, {sessions:{_id:this._id,reference:reference}})
        .then(result => {
          return resolve(result)
        })
        .catch(err => {
          return reject(err)
        })
      } else {
        let rem_ref_promises = this.reference_collections.map((coll, index) => {
          return this.removeReferenceByQuery(coll, {sessions:{_id:this._id,reference:reference}})
        })
        Promise.all(rem_ref_promises)
        .then(result => {
          return resolve(result)
        })
        .catch(err => {
          return reject(err)
        })
      }
    })
  }
  
  /**
   * Remove reference to document(s) using mongo style query.
   *
   * @param {string} collection - name of collection where reference should be removed
   * @param {string|Object} query - mongo style find query leading to documents in collection.
   * 
   * @returns {Promise} - resolves with count of documents where the reference was removed
   */
  removeReferenceByQuery(collection, query) {
    return new Promise((resolve, reject) => {
      if(!this.db.hasOwnProperty(collection)) {
        log.error(this.name, "can not remove reference. No collection " + collection)
        return reject("can not remove reference. No collection " + collection)
      }
      if(Array.isArray(query)) {
        query = query[0]// {name:{$in:query}}
      }
      if(typeof query === 'string') {
        try {
          query = JSON5.parse(query)
        } catch(err) {
          if(err instanceof SyntaxError) {
            query = {"name":query}
          } else {
            log.warn(this.name, 'Error when parsing to json:')
            log.warn(this.name, err)
          }
        }
      }
      
      this.db[collection].remove(query, {sessions:{_id:this._id}})
      .then(res => {
        log.debug(this.name, res.modifiedCount + ' references removed in ' + collection)
        return resolve(res.modifiedCount)
      })
      .catch(err => {
        return reject(err)
      })
    })
    
  }

  /**
  * collect information about cue based on its name  
  * iterate plugin modules to find matching cue keys in their schemes. On match forward cue properties to plugin. 
  * if cue content for plugin is array, forward elements successively so the session does not miss out on listeners nested in an array  
  * if plugin schema defines cue key as listener, store its properties in the listener collection.  
  * to identify listeners originating from this session, the session id is stored with the listener.  
  * if plugin resolves with a value of type string, cue dispatches an immideate followup cue with name of that string.  
  * If there is more than one followup, first cue property that resolves with string dispatches cue.  
  * Cues with immediate followups still install listeners, so they are properly canceled by next cue.
  * 
  * before cue actions are run, listeners of previous cues are canceled following these rules:
  * - cancel all listeners whose _path property array is contained in this cues path property array
  * - cancel all listeners whose _path property array contains this cues path property array
  * uses $all and https://docs.mongodb.com/manual/reference/operator/aggregation/setIsSubset/
  *
  * @todo cancel listeners if they were not installed.
  *
  * @param {Object|string} query - query to specify cue in cue array (e.g. {name:'cuename'})
  *                                 if query is string, cue is identified by name:query.
  *                                 if it contains '.' its regarded as &lt;chapter>.&lt;cue>
  * @param {string} [chapter='chapter'] - chapter the cue is in
  */
  cue(query, chapter)
  {
    if(typeof query === 'string') {
      let split_query = query.split('.')
      if(split_query.length > 1)
      {
        chapter = split_query[0]
        query = split_query[1]
      }
      query = {"name":query}
    }
    
    /** holds promises of all plugin cue functions waiting for them to return undefined, a nex t cue string or a listener cancel function */
    var cue_promise_data = []
    
    /** will hold cue data for this cue when resolved from level */
    var cue
    
    this.leveldoc.get()
    .then(lvl => {
      if(!chapter) {
        if(Object.keys(lvl.chapter).length == 1) {
          for(let ch in lvl.chapter) {
            chapter = ch
          }
          return this.leveldoc.pick('chapter.' + chapter, query)
        } else {
          throw new LevelError('there is more than one chapter. Please specify what chapter to address. (&lt;chapter>.&lt;cue>)')
        }
      } else if(lvl.chapter.hasOwnProperty(chapter)) {
        return this.leveldoc.pick('chapter.' + chapter, query)
      } else {
        throw new LevelError('chapter ' + chapter + ' could not be found')
      }
    })
    .then(cue_data => {
      if (cue_data.hasOwnProperty('name')) {
        cue = cue_data
        if (cue.hasOwnProperty('path')) {
          if(this.db.type == "mongodb") {
            return this.cancel({ $or:[{_path:{ $all: cue.path }},{$expr:{$setIsSubset:["$_path",cue.path]}}]}) // cancel all listener where cue path is in listener _path (path of _origin cue) or listener _path is in cue path 
          } else if(this.db.type == "nedb") {
            return this.cancelForNeDB(cue.path) // NeDB is missing some query operators. cancelForNeDB is the workaround.
          }
          
        } else {
          cue["path"] = "default"
        }
        return undefined
      }
      throw new LevelError("No cue found in chapter '" + chapter + "' with query:\n" + JSON.stringify(query))
    })
    .then(result => {
      log.info(this.name, "/------------------------------ Dispatch cue: " + chapter + "." + cue.name + " path: " + cue.path)
      let updt = {}
      updt[cue.name] = {date:new Date(Date.now()).toISOString()}
      return this.doc.set(updt)
    })
    .then(result => {
      this.client.emit('cue', {chapter:chapter, name:cue.name})
      //
      let cue_promises = []
      
      // TOOLS
      for(var t in this.plugins) {
        let plugin_cueschema = this.plugins[t]._schema.cue
        for(let cue_property in cue) {
          if(plugin_cueschema.hasOwnProperty(cue_property)) {
            if(plugin_cueschema[cue_property].type == "array") {
              for(let cue_prop_item of cue[cue_property]) {
                let cue_section = {}
                cue_section[cue_property] = cue_prop_item
                if(plugin_cueschema[cue_property].listener) {
                  let listener_data = Object.assign({}, cue_prop_item) // make a copy of the cue data so the stuff stored to DB is not manipulated before storage
                  cue_promises.push(Promise.resolve(this.forwardCue(cue_section, t, cue.name, cue.path, chapter, new Date(Date.now()))))
                  cue_promise_data.push({cue_property:cue_property, listener_data:listener_data, cuename:cue.name, plugin:t})
                } else {
                  cue_promises.push(Promise.resolve(this.forwardCue(cue_section, t, cue.name, cue.path, chapter, new Date(Date.now()))))
                  cue_promise_data.push({})
                }
              }
            } else {
              let cue_section = {}
              cue_section[cue_property] = cue[cue_property]
              if(plugin_cueschema[cue_property].listener) {
                let listener_data = Object.assign({}, cue[cue_property]) // make a copy of the cue data so the stuff stored to DB is not manipulated before storage
                cue_promises.push(Promise.resolve(this.forwardCue(cue_section, t, cue.name, cue.path, chapter, new Date(Date.now()))))
                cue_promise_data.push({cue_property:cue_property, listener_data:listener_data, cuename:cue.name, plugin:t})
              } else {
                cue_promises.push(Promise.resolve(this.forwardCue(cue_section, t, cue.name, cue.path, chapter, new Date(Date.now()))))
                cue_promise_data.push({})
              }
            }
          }
        }
      }
      return Promise.all(cue_promises)
    })
    .then(result => {
      let listener_promises = []
      if(result) {
        for(let i = 0; i &lt; result.length; i++) {
          if(typeof result[i] === "string") {
            this.next(result[i])
            break
          }
        }
        
        for(let i = 0; i &lt; result.length; i++) {
          if(typeof result[i] === "function"){
            listener_promises.push(this.installListener(cue_promise_data[i].cue_property, cue_promise_data[i].listener_data, result[i], cue_promise_data[i].cuename, cue.path, cue_promise_data[i].plugin))
          }
        }
      }
      return Promise.all(listener_promises)
    })
    .then(result => {
      log.info(this.name, cue.name + " resolved ----------------------------------------------------------------/")
      this.step()
    })
    .catch(err => {
      if(err instanceof LevelError) {
        log.error(this.name, err.message)
      } else if(err instanceof DesignError) {
        log.error(this.name, err.message)
      } else {
        log.error(this.name, err)
      }
      log.info(this.name, "cue resolved with error ------------------------------------------------------/")
      this.step()
    })
  }
  
  /**
  * is called once a cue finished doing his stuff
  * foremost cue in stack is removed.
  * If there is another cue in the stack already its being called
  */
  step() {
    //log.info("BEFORE STEP", this.cue_stack)
    this.cue_stack.shift()
    if(this.cue_stack.length > 0) {
      if(this.cue_stack[0].hasOwnProperty("chapter")) {
        this.cue(this.cue_stack[0].cue, this.cue_stack[0].chapter)
      } else {
        this.cue(this.cue_stack[0].cue)
      }
    }
    //log.info("AFTER STEP", this.cue_stack)
  }
  
  /**
  * trigger cue. Is used after forwarded as callback to plugin listener
  *
  * run cue immediate if there is no other cue in the stack.
  * Anyways enqueue it in stack.
  * 
  * The stack is required in case a listener is fireing before the cue itself is done processing all actions.
  */
  next(cue_query, chapter) {
    //log.info("BEFORE NEXT", this.cue_stack)
    if(this.cue_stack.length == 0) {
      if(chapter) {
        this.cue(cue_query, chapter)
      } else {
        this.cue(cue_query)
      }
    }
    this.cue_stack.push({cue:cue_query, chapter:chapter})
    //log.info("AFTER NEXT", this.cue_stack)
  }
  
  /**
  * forward cue elements to plugin responsible for cue segment
  * also forward objects that enable the plugin to identify and address this session
  *
  * @param {Object} content - cue element that is being forwarded
  * @param {Object} plugin - name of plugin module the cue properties shall be forwarded to
  * @param {string} cuename - name of origin cue
  * @param {Array} cuepath - path the origin cue is in
  * @param {string} chapter - chapter origin cue is in
  * @param {string} date - if cue is recalled due to server restart, this is the original date when it was dispatched
  *
  * @return {string|function|undefined} - may be a cue name string, a cancel function or undefined
  */
  forwardCue(content, plugin, cuename, cuepath, chapter, date) {
    for(let action in content) {
      var variables = new var_module.Variables(this.db, this.references, this._id, cuename, action)
    }
    
    let session_interface = {
      name:this.name, 
      _id:this._id,
      callback:this.next.bind(this), 
      createReference:(coll, query, ref) => this.createReference(coll, query, ref),
      splitPath:(cue, path) => this.splitPath(cue, path),
      joinPath:(path) => this.joinPath(path),
      event:this.event, 
      variables:variables, 
      path:cuepath, 
      chapter:chapter, 
      date:date, 
      cue:cuename
    }
    return this.plugins[plugin].cue(content, session_interface)
  }
  
  /**
  * store cue sections of type listener.
  * listeners that were stored are retriggered on session restart
  *
  * all listeners are stored as single items in the games listener Collection
  *
  * a timestamp is added. ObjectID also contains time data, but it seems it only is as accurate as 1s
  * 
  * @param {string} type - type identifier of listener
  * @param {Object} data - cue section that was flagged as listener
  * @param {Object} cancel_function - whatever the plugin module returned after installing the listener
  * @param {string} cue_name - name of cue the listener was installed in
  * @param {Array} path - path list of origin cue
  * @param {string} plugin - name of plugin the listener originates from
  */
  installListener(type, data, cancel_function, cue_name, path, plugin) {
    return new Promise((resolve, reject) => {
      let store = {
        _date: new Date(Date.now()).toISOString(),
        _origin: cue_name,
        _path: path,
        _session: this._id,
        _plugin: plugin,
        _type: type
      }
      store[type] = data
      this.db.listener.insert(store)
      .then(result => {
        store['_id'] = result.insertedId
        this.enqueue(store, cancel_function)
        return resolve(result)
      })
      .catch(error => {
        log.error(this.name, error)
      })
    })
  }
  
  /**
  * stack local instance of an installed listener including its object reference returned by plugin
  */
  enqueue(listener, cancel_function) {
    listener['cancel'] = cancel_function
    this.queue.push(listener)
  }
  
  /**
  * create a new path that runs parallel to the existing paths
  *
  * dispatch first cue for path. Cues path lists are established in webclient.
  *
  * @param {string} init_cue - cue that is triggered initially with path creation
  * @param {string} [name] - to identify path in flow
  */
  splitPath(init_cue, name) {
    log.info(this.name, "Split new path " + name + " and dispatch cue " + init_cue)
    this.next(init_cue)
  }

  /**
   * cancel all listeners for path
   * 
   * @deprecated
   * @param {Array} path - path list representing path to be joined 
   */
  joinPath(path) {
    this.cancel({"_path":path})
  }

  /**
   * cancel listener based on cue path when using NeDB. Finds all of sessions listener and uses Array.every to compare arrays.
   * 
   * nedb does neither suppert $all nor $expr operator
   * https://github.com/louischatriot/nedb/issues/278
   * this would cover 1 half of cancel query ($all):
   * let query = { $or:[{$and:[]}] }
   * for(let path of cue.path) {
   *   query["$or"][0]["$and"].push({_path:path})
   * }
   * But so far I didn't come up with a query for the second half ($expr/$setIsSubset)
   * @param {Array} path - current cue path list
   * @returns {Promise} - latest call is cancel() which returns array of removed listeners.
   */
  cancelForNeDB(path) {
    return new Promise((resolve, reject) => {
      let canceled_listener = []
      this.db.listener.find({"_session":this._id})
      .then(result => {
        for(let res of result) {
          let contains = res._path.every(r => {return path.includes(r)})
          let is_contained = path.every(r => {return res._path.includes(r)})
          if(contains || is_contained) {
            canceled_listener.push({_id:res._id})
          }
        }
        return this.cancel({$or:canceled_listener})
      })
      .then(result => {
        return resolve(result)
      })
      .catch(err => {
        return reject(err)
      })
    })
    
  }
  
  /**
  * removes all listeners that are matching the query and are assigned to the session.  
  * listeners are removed from listener collection 
  * once cancel function was called on and from local session queue after cancel function is called on queue item.
  *
  * @todo maybe (once needed) wait for plugins cancel functions to return promise before resolving this function
  *
  * @returns {Promise} array of deleted listener objects. Empty array if query didn't return listener. Resolves once all cancel functions returned.
  */
  cancel(query) {
    return new Promise((resolve, reject) => {
      let deleted_items = []
      if(typeof query === 'string') {
        query = {"_origin":query}
      }
      let full_query = {_session:this._id}
      Object.assign(full_query, query)
      this.db.listener.slice(full_query)
      .then(result => {
        if(result.length &lt;= 0) {
          // log.debug(this.name, "Cancel Query didn't match any listener: " + JSON.stringify(full_query))
          deleted_items = []
          return resolve()
        }
        let cancel_promises = []
        for(let res of result) {
          let l = undefined
          let index = -1
          for(let i = 0; i &lt; this.queue.length; i++) {
            if(this.db.listener.compareIDs(this.queue[i]._id, res._id)) {
              l = this.queue[i]
              index = i
              break
            }
          }
          if(l) {
            log.debug(this.name, "Cancel listener " + l._plugin + "." + l._type + " cue:" + l._origin + " path: [" + l._path + "] id: " + res._id)
            if(typeof l.cancel === "function") {
              cancel_promises.push( Promise.resolve( l.cancel() ) )
            } else if(typeof this.plugins[l._plugin].cancel === "function") {
              cancel_promises.push( Promise.resolve( this.plugins[l._plugin].cancel(l) ) )
            } else {
              throw new Error("Error when removing " + l._plugin + "." + l._type + " " + res._id + ". No cancel function defined")
            }
            deleted_items.push(this.queue.splice(index, 1)[0])
          } else {
            throw new Error("Couldn't remove " + res._plugin + "." + res._type + " " + res._id)
          }
        }
        return Promise.all(cancel_promises)
      })
      .then(result => {
        return resolve(deleted_items)
      })
      .catch(err => {
        return reject(err)
      })
    })
  }

  /**
  * cancel all listeners and remove all references to this session (player etc.)
  *
  * @returns {Promise} name and level
  */
  quit() {
    return new Promise((resolve, reject) => {
      this.cancel({})
      .then(res => {
        let removed_references = this.reference_collections.map((coll, index) => {
          return this.removeReferenceByQuery(coll, {sessions:{$exists:true}})
        })
        return Promise.all(removed_references)
      })
      .then(result => {
        return resolve({name:this.name, level:this.level})
      })
      .catch(err => {
        //log.error(this.name, err)
        return reject(err)
      })
    })
  }

  /**
  * communication with session control webview
  *
  * @param {Object} socket - io socket connection accessing session
  */
  clientConnection(socket) {
    // log.debug(this.name, "client connected")

    socket.on('this', function(msg) {
      if(this.hasOwnProperty(msg.data)) {
        try {
          socket.emit(msg.id,this[msg.data])
        } catch (e) {
          log.error(this.name + " socket", e)
        }
      } else {
        socket.emit(msg,undefined)
      }
    }.bind(this))
    
    socket.on('level', function(msg) {
      if(msg.hasOwnProperty('data')) {
        this.leveldoc.get()
        .then(function(result) {
          if(result.hasOwnProperty(msg.data)) {
            socket.emit(msg.id,result[msg.data])
          }
        }.bind(this))
        .catch(function(error){
          log.error(this.name, error)
        }.bind(this))
        
      } else {
        socket.emit(msg,undefined)
      }
    }.bind(this))

    socket.on('cue', function(msg) {
      log.info("socket cue", msg)
      this.next(msg.data.cue, msg.data.chapter)
    }.bind(this))
    
    socket.on('send', function(msg) {
      if(msg.hasOwnProperty('data')) {
        for(let device in msg.data) {
          if(this.devices.hasOwnProperty(device)) {
            this.devices[device].send(msg.data[device])
          }
        }
      }
    }.bind(this))
  }

  /**
  * react on std input addressing this session
  *
  */
  command(input) {
    switch(input[0]) {
      case "cue":
      if(input.length == 2) {
        this.next(input[1])
      } else if(input.length == 3) {
        this.next(input[2], input[1])
      }
      break
      case "listener":
      case "queue":
      if(input.length == 1) {
        for(let i = 0; i&lt;this.queue.length;i++) {
          log.info(i+"",this.queue[i]._date + ' cue:' + this.queue[i]._origin + ' path: [' + this.queue[i]._path + '] ' + this.queue[i]._plugin + '.' + this.queue[i]._type + ' ' + this.queue[i]._id)
        }
      } else if (input.length == 3) {
        if(input[1] == "cancel") {
          if(isNaN(input[2])) {
            if(input[2] == "all") {
              this.cancel({})
            } else {
              this.cancel(input[2])
            }
          } else if (this.queue.length > input[2] &amp;&amp; input[2] >= 0){
            this.cancel({_id:this.queue[input[2]]._id})
          } else {
            log.error(this.name, " listener queue index " + input[2] + " not in range")
          }
          
        }
      } else if (input.length == 4) {
        if(input[1] == "cancel") {
          let query = {}
          query[input[2]] = input[3]
          this.cancel(query)
        }
      }
      break
      case "load":
      case "assign":
      case "reference":
        if (input.length == 4) {
          this.createReference(input[1], {name:input[2]}, input[3])
        } else if(input[1] == "list") {
          log.info(this.name, this.references)
        } else {
          log.info(this.name, "load reference requires 3 arguments: collection, document name, reference name")
        }
        break
      case "player":
      this.db.player.find({'sessions._id':this._id})
      .then(result => {
        for(let res of result) {
          for(let session of res.sessions) {
            if(this.db.player.compareIDs(session._id, this._id)) {
              log.info(this.name, session.reference + ": " + res.name + " " + res.telnumber)
            }
          }
        }
      })
      break
      case "remove":
      if(input.length == 2) {
        this.removeReference(input[1])
      } else if(input.length == 3) {
        this.removeReferenceByQuery(input[1], input[2])
      } else if(input.length == 4) {
        let query = {}
        query[input[2]] = input[3]
        this.removeReferenceByQuery(input[1], query)
      } else {
        log.info(this.name, "To remove a reference provide an existing reference name or a query with collection, key and value")
      }
      break
      default:
      if(this.hasOwnProperty(input[0])) {
        for(let i = 0; i&lt;this[input[0]].length;i++) {
          if(this[input[0]][i].hasOwnProperty("_id")) {
            log.info(i+"",this[input[0]][i]._id)
          } else {
            log.warn(this.name, "id property missing for",input[0],"item")
          }
        }
      } else {
        log.info(this.name,"No such command '" + input[0] + "'")
      }
      break
    }
  }
}

class LevelError extends Error {
  constructor(...params) {
    super(...params)
    
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, LevelError);
    }
  }
}

module.exports = {
  Session:Session
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
